# Contributing

## Reporting Issues

We recommend the following guidelines for reporting bugs -

- For faster response, we recommend using [Kinvey support](https://support.kinvey.com/support/home).
- For bugs and enhancements specific to the library that are not time critical, please [file a GitHub issue](https://github.com/Kinvey/backbone-sdk/issues).

### Filing a bug

When filing a bug, please provide as much of the following information as possible -

- Steps to reproduce
- Expected result
- Actual result
- Sample code that demonstrates the issue
- Version of Kinvey / Device and toolset information
- Kinvey app ID (**never post your app secrets publicly**)


## Contributing Code

When contributing to the repository, please follow these guidelines -

- All contributions must be in the form of a pull request, with the `develop` branch as the base.
- Pull requests must pass the unit tests in the codebase. Whenever possible, new code should also add unit tests.
- Each commit should include a commit message describing the change; and each pull request should include a high level summary of the bug or enhancement being addressed by the pull request.
- The core team (Kinvey engineering) is currently responsible for reviewing, merging and releasing new code.

We require that all contributors sign a [CLA](https://goo.gl/forms/spZb2rXhC6I6zOxw1) prior to making a contribution. Please fill out the CLA so we can accept your contributions. If you have questions, you can email mobile@kinvey.com.
