'use strict';

var _kinveyJsSdk = require('kinvey-js-sdk');

var _kinveyPhonegapSdk = require('kinvey-phonegap-sdk');

var _kinveyPhonegapSdk2 = _interopRequireDefault(_kinveyPhonegapSdk);

var _backbone = require('backbone');

var _backbone2 = _interopRequireDefault(_backbone);

var _middleware = require('./middleware');

var _models = require('./models');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Override Backbone.sync
_backbone2.default.sync = _models.sync;

// Setup racks
_kinveyJsSdk.NetworkRack.useHttpMiddleware(new _middleware.HttpMiddleware());

// Add modules to Kinvey namespace
_kinveyPhonegapSdk2.default.Backbone = {
  Collection: _models.Collection,
  Model: _models.Model,
  Files: _models.Files,
  User: _models.User
};

// Export
module.exports = _kinveyPhonegapSdk2.default;